
_Main_Init:

;electronique_gradateur_lumiere_016_16f628.mpas,26 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,27 :: 		CMCON := 7;
	MOVLW      7
	MOVWF      CMCON+0
;electronique_gradateur_lumiere_016_16f628.mpas,28 :: 		OPTION_REG := 0;     // let pullup enabled
	CLRF       OPTION_REG+0
;electronique_gradateur_lumiere_016_16f628.mpas,30 :: 		TRISA := %11100000;
	MOVLW      224
	MOVWF      TRISA+0
;electronique_gradateur_lumiere_016_16f628.mpas,31 :: 		TRISB := %11111111;
	MOVLW      255
	MOVWF      TRISB+0
;electronique_gradateur_lumiere_016_16f628.mpas,32 :: 		PORTA := $00;
	CLRF       PORTA+0
;electronique_gradateur_lumiere_016_16f628.mpas,33 :: 		PORTB := $FF;
	MOVLW      255
	MOVWF      PORTB+0
;electronique_gradateur_lumiere_016_16f628.mpas,35 :: 		INTCON := 0;
	CLRF       INTCON+0
;electronique_gradateur_lumiere_016_16f628.mpas,36 :: 		INTCON.GIE := 0;       // |- enable interrupt (for UART and timer)
	BCF        INTCON+0, 7
;electronique_gradateur_lumiere_016_16f628.mpas,37 :: 		INTCON.PEIE := 0;      // |  will be enabled later, after main init
	BCF        INTCON+0, 6
;electronique_gradateur_lumiere_016_16f628.mpas,42 :: 		T1CON := 0;
	CLRF       T1CON+0
;electronique_gradateur_lumiere_016_16f628.mpas,44 :: 		T1CON.T1CKPS1 := 0;  // bits 5-4  Prescaler Rate Select bits
	BCF        T1CON+0, 5
;electronique_gradateur_lumiere_016_16f628.mpas,45 :: 		T1CON.T1CKPS0 := 1;  // bit 4
	BSF        T1CON+0, 4
;electronique_gradateur_lumiere_016_16f628.mpas,46 :: 		T1CON.T1OSCEN := 0;  // bit 3 Timer1 Oscillator Enable Control: bit 1=on
	BCF        T1CON+0, 3
;electronique_gradateur_lumiere_016_16f628.mpas,47 :: 		T1CON.NOT_T1SYNC  := 1;  // bit 2 Timer1 External Clock Input Synchronization Control bit:1=Do not synchronize external clock input
	BSF        T1CON+0, 2
;electronique_gradateur_lumiere_016_16f628.mpas,48 :: 		T1CON.TMR1CS  := 0;  // bit 1 Timer1 Clock Source Select bit:0=Internal clock (FOSC/4) / 1 = External clock from pin T1CKI (on the rising edge)
	BCF        T1CON+0, 1
;electronique_gradateur_lumiere_016_16f628.mpas,50 :: 		TMR1H := cTMR1H;     // preset for timer1 MSB register
	MOVLW      60
	MOVWF      TMR1H+0
;electronique_gradateur_lumiere_016_16f628.mpas,51 :: 		TMR1L := cTMR1L;     // preset for timer1 LSB register
	MOVLW      176
	MOVWF      TMR1L+0
;electronique_gradateur_lumiere_016_16f628.mpas,52 :: 		PIE1 := 0;
	CLRF       PIE1+0
;electronique_gradateur_lumiere_016_16f628.mpas,53 :: 		PIE1.TMR1IE := 0;    // enable Timer1 interrupt, will be enabled later
	BCF        PIE1+0, 0
;electronique_gradateur_lumiere_016_16f628.mpas,54 :: 		PIR1 := 0;
	CLRF       PIR1+0
;electronique_gradateur_lumiere_016_16f628.mpas,55 :: 		PIR1.TMR1IF := 0;    // reset Timer1 Interrupt flag
	BCF        PIR1+0, 0
;electronique_gradateur_lumiere_016_16f628.mpas,58 :: 		T2CON := 0;
	CLRF       T2CON+0
;electronique_gradateur_lumiere_016_16f628.mpas,60 :: 		iIntT1Count := 1;
	MOVLW      1
	MOVWF      _iIntT1Count+0
;electronique_gradateur_lumiere_016_16f628.mpas,61 :: 		bOneSec := false;
	CLRF       _bOneSec+0
;electronique_gradateur_lumiere_016_16f628.mpas,64 :: 		iPwmCanChangeDuty := 0;
	CLRF       _iPwmCanChangeDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,66 :: 		if In_PwmUp then
	BTFSS      RB2_bit+0, 2
	GOTO       L__Main_Init2
;electronique_gradateur_lumiere_016_16f628.mpas,67 :: 		iPwmDuty := 0
	CLRF       _iPwmDuty+0
	GOTO       L__Main_Init3
;electronique_gradateur_lumiere_016_16f628.mpas,69 :: 		else
L__Main_Init2:
;electronique_gradateur_lumiere_016_16f628.mpas,70 :: 		iPwmDuty := 255;
	MOVLW      255
	MOVWF      _iPwmDuty+0
L__Main_Init3:
;electronique_gradateur_lumiere_016_16f628.mpas,71 :: 		PWM1_Init(1000);
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	BSF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      249
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;electronique_gradateur_lumiere_016_16f628.mpas,73 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_gradateur_lumiere_016_16f628.mpas,76 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,78 :: 		if PIR1.TMR1IF then
	BTFSS      PIR1+0, 0
	GOTO       L__Interrupt6
;electronique_gradateur_lumiere_016_16f628.mpas,80 :: 		bIntT1 := true;
	MOVLW      255
	MOVWF      _bIntT1+0
;electronique_gradateur_lumiere_016_16f628.mpas,81 :: 		TMR1H := cTMR1H;
	MOVLW      60
	MOVWF      TMR1H+0
;electronique_gradateur_lumiere_016_16f628.mpas,82 :: 		TMR1L := cTMR1L;
	MOVLW      176
	MOVWF      TMR1L+0
;electronique_gradateur_lumiere_016_16f628.mpas,83 :: 		PIR1.TMR1IF := 0;
	BCF        PIR1+0, 0
;electronique_gradateur_lumiere_016_16f628.mpas,84 :: 		end;
L__Interrupt6:
;electronique_gradateur_lumiere_016_16f628.mpas,85 :: 		end;
L_end_Interrupt:
L__Interrupt65:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Main_GetDelay:

;electronique_gradateur_lumiere_016_16f628.mpas,88 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,90 :: 		end;
L_end_Main_GetDelay:
	RETURN
; end of _Main_GetDelay

_Main_DoDelay:

;electronique_gradateur_lumiere_016_16f628.mpas,93 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,95 :: 		end;
L_end_Main_DoDelay:
	RETURN
; end of _Main_DoDelay

_Interrupts_Enable:

;electronique_gradateur_lumiere_016_16f628.mpas,98 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,99 :: 		INTCON.PEIE := 1;   // enable periph. int.
	BSF        INTCON+0, 6
;electronique_gradateur_lumiere_016_16f628.mpas,100 :: 		PIE1.TMR1IE := 1;   // enable Timer1
	BSF        PIE1+0, 0
;electronique_gradateur_lumiere_016_16f628.mpas,101 :: 		T1CON.TMR1ON := 1;
	BSF        T1CON+0, 0
;electronique_gradateur_lumiere_016_16f628.mpas,102 :: 		INTCON.GIE := 1;    // enable global interrupts
	BSF        INTCON+0, 7
;electronique_gradateur_lumiere_016_16f628.mpas,103 :: 		end;
L_end_Interrupts_Enable:
	RETURN
; end of _Interrupts_Enable

_PWM_ClearDuty:

;electronique_gradateur_lumiere_016_16f628.mpas,106 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,107 :: 		if In_PwmUp then
	BTFSS      RB2_bit+0, 2
	GOTO       L__PWM_ClearDuty13
;electronique_gradateur_lumiere_016_16f628.mpas,109 :: 		iPwmDuty := 1;
	MOVLW      1
	MOVWF      _iPwmDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,110 :: 		PWM1_Set_Duty(iPwmDuty);
	MOVLW      1
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;electronique_gradateur_lumiere_016_16f628.mpas,112 :: 		end
	GOTO       L__PWM_ClearDuty14
;electronique_gradateur_lumiere_016_16f628.mpas,113 :: 		else
L__PWM_ClearDuty13:
;electronique_gradateur_lumiere_016_16f628.mpas,115 :: 		iPwmDuty := 255;
	MOVLW      255
	MOVWF      _iPwmDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,116 :: 		PWM1_Set_Duty(iPwmDuty);
	MOVLW      255
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;electronique_gradateur_lumiere_016_16f628.mpas,118 :: 		end;
L__PWM_ClearDuty14:
;electronique_gradateur_lumiere_016_16f628.mpas,119 :: 		end;
L_end_PWM_ClearDuty:
	RETURN
; end of _PWM_ClearDuty

_PWM_GetChangeDutyDelay:

;electronique_gradateur_lumiere_016_16f628.mpas,122 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,123 :: 		iPwmChangeDutyDelay := 0;
	CLRF       _iPwmChangeDutyDelay+0
;electronique_gradateur_lumiere_016_16f628.mpas,124 :: 		if In_DutyDelay0 then
	BTFSS      RB4_bit+0, 4
	GOTO       L__PWM_GetChangeDutyDelay17
;electronique_gradateur_lumiere_016_16f628.mpas,125 :: 		iPwmChangeDutyDelay := iPwmChangeDutyDelay + 1;
	INCF       _iPwmChangeDutyDelay+0, 1
L__PWM_GetChangeDutyDelay17:
;electronique_gradateur_lumiere_016_16f628.mpas,126 :: 		if In_DutyDelay1 then
	BTFSS      RB5_bit+0, 5
	GOTO       L__PWM_GetChangeDutyDelay20
;electronique_gradateur_lumiere_016_16f628.mpas,127 :: 		iPwmChangeDutyDelay := iPwmChangeDutyDelay + 2;
	MOVLW      2
	ADDWF      _iPwmChangeDutyDelay+0, 1
L__PWM_GetChangeDutyDelay20:
;electronique_gradateur_lumiere_016_16f628.mpas,128 :: 		if In_DutyDelay2 then
	BTFSS      RB6_bit+0, 6
	GOTO       L__PWM_GetChangeDutyDelay23
;electronique_gradateur_lumiere_016_16f628.mpas,129 :: 		iPwmChangeDutyDelay := iPwmChangeDutyDelay + 4;
	MOVLW      4
	ADDWF      _iPwmChangeDutyDelay+0, 1
L__PWM_GetChangeDutyDelay23:
;electronique_gradateur_lumiere_016_16f628.mpas,130 :: 		if In_DutyDelay3 then
	BTFSS      RB7_bit+0, 7
	GOTO       L__PWM_GetChangeDutyDelay26
;electronique_gradateur_lumiere_016_16f628.mpas,131 :: 		iPwmChangeDutyDelay := iPwmChangeDutyDelay + 8;
	MOVLW      8
	ADDWF      _iPwmChangeDutyDelay+0, 1
L__PWM_GetChangeDutyDelay26:
;electronique_gradateur_lumiere_016_16f628.mpas,132 :: 		result := iPwmChangeDutyDelay;
	MOVF       _iPwmChangeDutyDelay+0, 0
	MOVWF      R1+0
;electronique_gradateur_lumiere_016_16f628.mpas,133 :: 		end;
	MOVF       R1+0, 0
	MOVWF      R0+0
L_end_PWM_GetChangeDutyDelay:
	RETURN
; end of _PWM_GetChangeDutyDelay

_PWM_ChangeDuty:

;electronique_gradateur_lumiere_016_16f628.mpas,136 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,139 :: 		PORTA.0 := In_PwmUp;
	BTFSC      RB2_bit+0, 2
	GOTO       L__PWM_ChangeDuty72
	BCF        PORTA+0, 0
	GOTO       L__PWM_ChangeDuty73
L__PWM_ChangeDuty72:
	BSF        PORTA+0, 0
L__PWM_ChangeDuty73:
;electronique_gradateur_lumiere_016_16f628.mpas,141 :: 		if iPwmCanChangeDuty < PWM_GetChangeDutyDelay then
	CALL       _PWM_GetChangeDutyDelay+0
	MOVF       R0+0, 0
	SUBWF      _iPwmCanChangeDuty+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__PWM_ChangeDuty30
;electronique_gradateur_lumiere_016_16f628.mpas,143 :: 		inc(iPwmCanChangeDuty);
	INCF       _iPwmCanChangeDuty+0, 1
;electronique_gradateur_lumiere_016_16f628.mpas,144 :: 		end
	GOTO       L__PWM_ChangeDuty31
;electronique_gradateur_lumiere_016_16f628.mpas,145 :: 		else
L__PWM_ChangeDuty30:
;electronique_gradateur_lumiere_016_16f628.mpas,147 :: 		bPwmCanChangeDuty := true;
	MOVLW      255
	MOVWF      _bPwmCanChangeDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,148 :: 		iPwmCanChangeDuty := 0;
	CLRF       _iPwmCanChangeDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,149 :: 		end;
L__PWM_ChangeDuty31:
;electronique_gradateur_lumiere_016_16f628.mpas,150 :: 		if bPwmCanChangeDuty then
	MOVF       _bPwmCanChangeDuty+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__PWM_ChangeDuty33
;electronique_gradateur_lumiere_016_16f628.mpas,152 :: 		if In_PwmUp then
	BTFSS      RB2_bit+0, 2
	GOTO       L__PWM_ChangeDuty36
;electronique_gradateur_lumiere_016_16f628.mpas,154 :: 		if iPwmDuty < 255 then
	MOVLW      255
	SUBWF      _iPwmDuty+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__PWM_ChangeDuty39
;electronique_gradateur_lumiere_016_16f628.mpas,155 :: 		inc(iPwmDuty);
	INCF       _iPwmDuty+0, 1
L__PWM_ChangeDuty39:
;electronique_gradateur_lumiere_016_16f628.mpas,156 :: 		end
	GOTO       L__PWM_ChangeDuty37
;electronique_gradateur_lumiere_016_16f628.mpas,157 :: 		else
L__PWM_ChangeDuty36:
;electronique_gradateur_lumiere_016_16f628.mpas,159 :: 		if iPwmDuty > 0 then
	MOVF       _iPwmDuty+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__PWM_ChangeDuty42
;electronique_gradateur_lumiere_016_16f628.mpas,160 :: 		dec(iPwmDuty);
	DECF       _iPwmDuty+0, 1
L__PWM_ChangeDuty42:
;electronique_gradateur_lumiere_016_16f628.mpas,161 :: 		end;
L__PWM_ChangeDuty37:
;electronique_gradateur_lumiere_016_16f628.mpas,162 :: 		PWM1_Set_Duty(iPwmDuty);
	MOVF       _iPwmDuty+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;electronique_gradateur_lumiere_016_16f628.mpas,163 :: 		bPwmCanChangeDuty := false;
	CLRF       _bPwmCanChangeDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,164 :: 		end;
L__PWM_ChangeDuty33:
;electronique_gradateur_lumiere_016_16f628.mpas,165 :: 		end;
L_end_PWM_ChangeDuty:
	RETURN
; end of _PWM_ChangeDuty

_Main_Welcome:

;electronique_gradateur_lumiere_016_16f628.mpas,168 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,170 :: 		end;
L_end_Main_Welcome:
	RETURN
; end of _Main_Welcome

_main:

;electronique_gradateur_lumiere_016_16f628.mpas,172 :: 		begin
;electronique_gradateur_lumiere_016_16f628.mpas,173 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_gradateur_lumiere_016_16f628.mpas,174 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_gradateur_lumiere_016_16f628.mpas,175 :: 		Main_GetDelay;
	CALL       _Main_GetDelay+0
;electronique_gradateur_lumiere_016_16f628.mpas,176 :: 		Interrupts_Enable(true);
	MOVLW      255
	MOVWF      FARG_Interrupts_Enable_bState+0
	CALL       _Interrupts_Enable+0
;electronique_gradateur_lumiere_016_16f628.mpas,177 :: 		PWM1_Start;
	CALL       _PWM1_Start+0
;electronique_gradateur_lumiere_016_16f628.mpas,178 :: 		PWM_ClearDuty;
	CALL       _PWM_ClearDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,179 :: 		while true do
L__main47:
;electronique_gradateur_lumiere_016_16f628.mpas,181 :: 		if bIntT1 then
	MOVF       _bIntT1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main52
;electronique_gradateur_lumiere_016_16f628.mpas,183 :: 		if In_TB then
	BTFSS      RB1_bit+0, 1
	GOTO       L__main55
;electronique_gradateur_lumiere_016_16f628.mpas,185 :: 		if iIntT1Count < 10 then
	MOVLW      10
	SUBWF      _iIntT1Count+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main58
;electronique_gradateur_lumiere_016_16f628.mpas,186 :: 		inc(iIntT1Count)
	INCF       _iIntT1Count+0, 1
	GOTO       L__main59
;electronique_gradateur_lumiere_016_16f628.mpas,187 :: 		else
L__main58:
;electronique_gradateur_lumiere_016_16f628.mpas,189 :: 		iIntT1Count := 1;
	MOVLW      1
	MOVWF      _iIntT1Count+0
;electronique_gradateur_lumiere_016_16f628.mpas,190 :: 		bOneSec := true;
	MOVLW      255
	MOVWF      _bOneSec+0
;electronique_gradateur_lumiere_016_16f628.mpas,191 :: 		end;
L__main59:
;electronique_gradateur_lumiere_016_16f628.mpas,192 :: 		end
	GOTO       L__main56
;electronique_gradateur_lumiere_016_16f628.mpas,193 :: 		else
L__main55:
;electronique_gradateur_lumiere_016_16f628.mpas,195 :: 		bOneSec := true; // go faster (* 10)
	MOVLW      255
	MOVWF      _bOneSec+0
;electronique_gradateur_lumiere_016_16f628.mpas,196 :: 		end;
L__main56:
;electronique_gradateur_lumiere_016_16f628.mpas,197 :: 		if bOneSec then
	MOVF       _bOneSec+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main61
;electronique_gradateur_lumiere_016_16f628.mpas,199 :: 		Main_DoDelay;
	CALL       _Main_DoDelay+0
;electronique_gradateur_lumiere_016_16f628.mpas,200 :: 		Out_LED := Out_LED xor 1;
	MOVLW      16
	XORWF      RA4_bit+0, 1
;electronique_gradateur_lumiere_016_16f628.mpas,201 :: 		PWM_ChangeDuty;
	CALL       _PWM_ChangeDuty+0
;electronique_gradateur_lumiere_016_16f628.mpas,202 :: 		bOneSec := false;
	CLRF       _bOneSec+0
;electronique_gradateur_lumiere_016_16f628.mpas,203 :: 		end;
L__main61:
;electronique_gradateur_lumiere_016_16f628.mpas,204 :: 		bIntT1 := false;
	CLRF       _bIntT1+0
;electronique_gradateur_lumiere_016_16f628.mpas,205 :: 		end;
L__main52:
;electronique_gradateur_lumiere_016_16f628.mpas,206 :: 		end;
	GOTO       L__main47
;electronique_gradateur_lumiere_016_16f628.mpas,207 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
